include	clib.inc

ifdef __ZIP__

include	iost.inc
include	string.inc
include	wsub.inc
include	fblk.inc
include	unzip.inc
include	malloc.inc

	.186

	public	arc_flength
	extrn	_bufin:BYTE

_TEXT	SEGMENT

stditobufin PROC
	xor	ax,ax
	mov	STDI.ios_i,ax
	mov	STDI.ios_c,ax
	mov	STDI.ios_flag,ax
	mov	STDI.ios_size,4096
	mov	STDI.ios_bp_dx,ds
	mov	STDI.ios_bp_ax,offset _bufin
	ret
stditobufin ENDP

getendcentral PROC	; (WSUB *, ZEND *)
	push	bp
	mov	bp,sp
	push	[bp+10]
	push	[bp+8]
	call	wsopenarch
	mov	STDI.ios_file,ax
	dec	ax
	jnz	getendcentral_get
    getendcentral_end:
	pop	bp
	ret	8
    getendcentral_eof:
	xor	ax,ax
    getendcentral_close:
	or	ax,ax
	jnz	getendcentral_end
	push	STDI.ios_file
	call	close
	xor	ax,ax
	jmp    getendcentral_end
    getendcentral_get:
	call	stditobufin
	push	ax
	push	ax
	push	SEEK_END
	call	oseekl
	jz	getendcentral_eof
	mov	ax,STDI.ios_offset_ax
	mov	arc_flength_ax,ax
	mov	arc_flength_dx,dx
	or	dx,dx
	jnz	getendcentral_seekback
	cmp	ax,SIZE S_ZEND
	jb	getendcentral_eof
    getendcentral_seekback:
	call	oungetc
	jz	getendcentral_eof
	cmp	STDI.ios_i,SIZE S_ZEND-1
	jb	getendcentral_eof
	sub	STDI.ios_i,SIZE S_ZEND-2
    getendcentral_loop:
	call	oungetc
	jz	getendcentral_eof
	cmp	al,'P'
	jne	getendcentral_loop
	mov	ax,SIZE S_ZEND
	call	oread
	jz      getendcentral_eof
	mov	ax,[bx]
	mov	dx,[bx+2]
	cmp	ax,ZIPHEADERID
	jne	getendcentral_loop
	cmp	dx,ZIPENDSENTRID
	jne	getendcentral_loop
	push	[bp+6]
	push	[bp+4]
	push	ds
	push	bx
	push	SIZE S_ZEND
	call	memcpy
	mov	ax,1
	jmp	getendcentral_close
getendcentral ENDP

zip_readcentral PROC
	push	si
	push	di
	mov	ax,SIZE S_CZIP
	call	oread
	jz	readcentral_eof
	push	ds
	push	offset zip_central
	push	es
	push	bx
	push	SIZE S_CZIP
	call	memcpy
	add	STDI.ios_i,SIZE S_CZIP
	cmp	zip_central.cz_pkzip,ZIPHEADERID
	jne	readcentral_eof
	cmp	zip_central.cz_zipid,ZIPCENTRALID
	jne	readcentral_eof
	mov	ax,zip_central.cz_fnsize
	call	oread
	jz	readcentral_eof
	mov	ax,zip_central.cz_fnsize
	add	STDI.ios_i,ax
	push	ds
	push	offset entryname
	push	es
	push	bx
	push	ax
	mov	bx,ax
	mov	entryname[bx],0
	call	memcpy
	mov	zip_attrib,_A_ZIP or _A_ARCH
	test	BYTE PTR zip_central.cz_bitflag,1
	jz	readcentral_nocrypt
	or	zip_attrib,_A_ENCRYPTED
    readcentral_nocrypt:
	test	BYTE PTR zip_central.cz_bitflag,8
	jz	readcentral_name
	or	zip_attrib,_A_EXTLOCHD
	jmp	readcentral_name
    readcentral_eof:
	xor	ax,ax
    readcentral_end:
	or	ax,ax
	pop	di
	pop	si
	ret
    readcentral_name:
	mov	ax,'/'
	mov	di,zip_central.cz_fnsize
	mov	[di+entryname],ah
	dec	di
	cmp	[di+entryname],al
	jne	readcentral_size
	mov	[di+entryname],ah
	or	zip_attrib,_A_SUBDIR
    readcentral_size:
	mov	di,zip_central.cz_extsize
	add	di,zip_central.cz_cmtsize
	jz	readcentral_unix
	mov	ax,di
	call	oread
	jz	readcentral_eof
	add	STDI.ios_i,di
    readcentral_unix:
	push	ds
	push	offset entryname
	call	unixtodos
	mov	ax,1
	jmp	readcentral_end
zip_readcentral ENDP

zip_testcentral PROC
	push	bp
	mov	bp,sp
	push	si
	push	di
	mov	si,OFFSET entryname
	les	bx,[bp+4]
	push	word ptr es:[bx.ws_arch+2]
	push	word ptr es:[bx.ws_arch]
	call	strlen
	mov	di,ax
	or	ax,ax
	jz	testcentral_00
	push	ds
	push	si
	les	bx,[bp+4]
	push	word ptr es:[bx.ws_arch+2]
	push	word ptr es:[bx.ws_arch]
	push	di
	call	strnicmp
	or	ax,ax
	jnz	testcentral_03
    testcentral_00:
	push	ds
	push	si
	call	strlen
	cmp	di,ax
	jae	testcentral_03
	or	di,di
	jz	testcentral_01
	cmp	[di+entryname],'\'
	jne	testcentral_03
	push	ds
	push	si
	mov	ax,si
	inc	ax
	add	ax,di
	push	ds
	push	ax
	call	strcpy
    testcentral_01:
	cmp	entryname,','
	jne	testcentral_02
	push	ds
	push	si
	inc	si
	push	ds
	push	si
	dec	si
	call	strcpy
    testcentral_02:
	push	ds
	push	si
	push	'\'
	call	strchr
	jz	testcentral_04
	mov	es,dx
	mov	bx,ax
	mov	BYTE PTR es:[bx],0
	push	[bp+6]
	push	[bp+4]
	push	ds
	push	si
	call	wsearch
	cmp	ax,-1
	jne	testcentral_03
	mov	ax,2
	jmp	testcentral_06
    testcentral_03:
	xor	ax,ax
	jmp	testcentral_06
    testcentral_04:
	push	[bp+6]
	push	[bp+4]
	push	ds
	push	si
	call	wsearch
	cmp	ax,-1
	je	testcentral_05
	les	bx,[bp+4]
	les	bx,es:[bx.ws_fcb]
	shl	ax,2
	add	bx,ax
	les	bx,es:[bx]
	mov	ax,zip_central.cz_date
	mov	dx,zip_central.cz_time
	mov	es:[bx.fb_time],dx
	mov	es:[bx.fb_date],ax
	cmp	zip_central.cz_version_made,0
	jne	testcentral_03
	mov	ax,zip_central.cz_ext_attrib
	or	ax,zip_attrib
	and	ax,_A_FATTRIB
	mov	es:[bx],ax
	jmp	testcentral_03
    testcentral_05:
	mov	ax,1
    testcentral_06:
	pop	di
	pop	si
	pop	bp
	ret	4
zip_testcentral ENDP

zip_allocfblk PROC
	push	si
	push	di
	mov	si,OFFSET entryname
	push	ds
	push	si
	mov	di,ax
	call	strlen
	add	ax,SIZE S_FBLK
	push	ax
	add	ax,12
	push	ax
	call	malloc
	pop	cx
	jz	allocfblk_01
	mov	bx,ax
	mov	ax,zip_central.cz_ext_attrib
	and	ax,_A_FATTRIB
	or	ax,zip_attrib
	mov	es,dx
	mov	es:[bx],ax
	cmp	di,2
	mov	di,cx
	jne	allocfblk_02
	cmp	zip_central.cz_version_made,0
	jne	allocfblk_00
	test	BYTE PTR zip_central.cz_ext_attrib,_A_SUBDIR
	jnz	allocfblk_03
    allocfblk_00:
	mov	ax,zip_attrib
	or	ax,_A_SUBDIR
	mov	es:[bx],ax
	jmp	allocfblk_03
    allocfblk_01:
	xor	ax,ax
	mov	dx,ax
	jmp	allocfblk_05
    allocfblk_02:
	mov	ax,zip_central.cz_fsize_dx
	mov	WORD PTR es:[bx.fb_size+2],ax
	mov	ax,zip_central.cz_fsize_ax
	mov	WORD PTR es:[bx.fb_size],ax
    allocfblk_03:
	push	dx
	push	bx
	mov	ax,zip_central.cz_date
	mov	es:[bx.fb_date],ax
	mov	ax,zip_central.cz_time
	mov	es:[bx.fb_time],ax
	push	dx
	add	bx,fb_name
	push	bx
	push	ds
	push	si
    allocfblk_04:
	call	strcpy
	sub	ax,fb_name
	add	di,ax
	mov	ax,zip_central.cz_off_local_ax
	stosw
	mov	ax,zip_central.cz_off_local_dx
	stosw
	mov	ax,zip_central.cz_csize_ax
	stosw
	mov	ax,zip_central.cz_csize_dx
	stosw
	mov	ax,zip_central.cz_crc_ax
	stosw
	mov	ax,zip_central.cz_crc_dx
	stosw
	pop	ax
	pop	dx
    allocfblk_05:
	pop	di
	pop	si
	ret
zip_allocfblk ENDP

zip_findnext PROC
	call	zip_readcentral
	or	ax,ax
	jz	zip_findnext_02
    zip_findnext_00:
	push	si
	push	di
	call	zip_testcentral
	or	ax,ax
	jz	zip_findnext_01
	call	zip_allocfblk
	jmp	zip_findnext_02
    zip_findnext_01:
	call	zip_readcentral
	or	ax,ax
	jnz	zip_findnext_00
	xor	ax,ax
	mov	dx,ax
    zip_findnext_02:
	ret
zip_findnext ENDP

_TEXT	ENDS

PPROC	wzipread, wsub:DWORD
local	fblk_ax:WORD
local	fblk_dx:WORD
	push	si
	push	di
	mov	si,WORD PTR wsub+2
	mov	di,WORD PTR wsub
	push	si
	push	di
	call	wsfree
	push	si
	push	di
	push	ds
	push	OFFSET zip_endcent
	call	getendcentral
	jnz	wzipread_00
	mov	ax,-2
	jmp	wzipread_06
    wzipread_00:
	push	_A_ZIP
	call	fbupdir
	mov	es,si
	mov	es:[di.ws_count],1
	les	bx,es:[di.ws_fcb]
	mov	es:[bx+2],dx
	mov	es:[bx],ax
	push	zip_endcent.ze_off_cent_dx
	push	zip_endcent.ze_off_cent_ax
	push	SEEK_SET
	call	oseek
	call	zip_findnext
	mov	fblk_ax,ax
	mov	fblk_dx,dx
	or	ax,ax
	jz	wzipread_05
    wzipread_02:
	mov	bx,ax
	mov	al,es:[0004h]
	and	al,_A_SUBDIR
	jnz	wzipread_03
	push	dx
	add	bx,fb_name
	push	bx
	mov	es,si
	push	WORD PTR es:[di.ws_mask+2]
	push	WORD PTR es:[di.ws_mask]
	call	cmpwarg
	jnz	wzipread_03
	push	fblk_dx
	push	fblk_ax
	call	free
	jmp	wzipread_04
    wzipread_03:
	mov	es,si
	mov	ax,es:[di.ws_count]
	les	bx,es:[di.ws_fcb]
	shl	ax,2
	add	bx,ax
	mov	ax,fblk_dx
	mov	es:[bx+2],ax
	mov	ax,fblk_ax
	mov	es:[bx],ax
	mov	es,si
	inc	es:[di.ws_count]
	mov	ax,es:[di.ws_count]
	cmp	ax,es:[di.ws_maxfb]
	jae	wzipread_05
    wzipread_04:
	call	zip_findnext
	mov	fblk_ax,ax
	mov	fblk_dx,dx
	or	ax,ax
	jnz	wzipread_02
    wzipread_05:
	push	STDI.ios_file
	call	close
	mov	es,si
	mov	ax,es:[di]
    wzipread_06:
	mov	STDI.ios_size,ISIZE
	pop	di
	pop	si
	ret
PEND	wzipread

_DATA	SEGMENT

arc_flength	LABEL DWORD
arc_flength_ax	DW ?
arc_flength_dx	DW ?

_DATA	ENDS

endif

	END
